import { ItemStack, Items, world } from "@minecraft/server";
import { ModalFormData } from "@minecraft/server-ui";



/**
 * @description This will specify the blocks information for the menu to open
*/
let block = {
    typeId: "sra:scp_294",
    InteractItem: "minecraft:iron_nugget"
}



/**
 * @description Specify drinks here to search when typed in the textfield of the menu
*/
let Drinks = {
    "Apple Juice": {
        ItemType: "sra:cup_of_apple_juice",
        Amount: 1,
        //Specify the cost of the item
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Orange Juice": {
        ItemType: "sra:cup_of_orange_juice",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Cola": {
        ItemType: "sra:cup_of_cola",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Coffee": {
        ItemType: "sra:cup_of_coffee",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 3
        }
    },
    "Enchanted Golden Apple": {
        ItemType: "sra:cup_of_enchanted_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 46
        }
    },
    "Golden Apple": {
        ItemType: "sra:cup_of_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 32
        }
    },
    "Lava": {
        ItemType: "sra:cup_of_lava",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Lemonade": {
        ItemType: "sra:cup_of_lemonade",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Milk": {
        ItemType: "sra:cup_of_milk",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 3
        }
    },
    "SCP-075 Corrosion": {
        ItemType: "sra:cup_of_scp_075_corrosion",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Water": {
        ItemType: "sra:cup_of_water",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "cola": {
        ItemType: "sra:cup_of_cola",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "apple juice": {
        ItemType: "sra:cup_of_apple_juice",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "orange juice": {
        ItemType: "sra:cup_of_orange_juice",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "coffee": {
        ItemType: "sra:cup_of_coffee",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 3
        }
    },
    "enchanted golden apple": {
        ItemType: "sra:cup_of_enchanted_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 46
        }
    },
    "golden apple": {
        ItemType: "sra:cup_of_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 32
        }
    },
    "lava": {
        ItemType: "sra:cup_of_lava",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "lemonade": {
        ItemType: "sra:cup_of_lemonade",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "milk": {
        ItemType: "sra:cup_of_milk",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 3
        }
    },
    "SCP-075 corrosion": {
        ItemType: "sra:cup_of_scp_075_corrosion",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "scp-075 corrosion": {
        ItemType: "sra:cup_of_scp_075_corrosion",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "scp-075 Corrosion": {
        ItemType: "sra:cup_of_scp_075_corrosion",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "water": {
        ItemType: "sra:cup_of_water",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "enchanted Golden Apple": {
        ItemType: "sra:cup_of_enchanted_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 46
        }
    },
    "Enchanted golden Apple": {
        ItemType: "sra:cup_of_enchanted_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 46
        }
    },
    "Enchanted Golden apple": {
        ItemType: "sra:cup_of_enchanted_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 46
        }
    },
    "enchanted golden Apple": {
        ItemType: "sra:cup_of_enchanted_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 46
        }
    },
    "Enchanted golden apple": {
        ItemType: "sra:cup_of_enchanted_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 46
        }
    },
    "enchanted Golden apple": {
        ItemType: "sra:cup_of_enchanted_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 46
        }
    },
    "Enchanted golden Apple": {
        ItemType: "sra:cup_of_enchanted_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 46
        }
    },
    "golden Apple": {
        ItemType: "sra:cup_of_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 32
        }
    },
    "Golden apple": {
        ItemType: "sra:cup_of_golden_apple",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 32
        }
    },
    "Apple juice": {
        ItemType: "sra:cup_of_apple_juice",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "apple Juice": {
        ItemType: "sra:cup_of_apple_juice",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Orange juice": {
        ItemType: "sra:cup_of_orange_juice",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "orange Juice": {
        ItemType: "sra:cup_of_orange_juice",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Blood": {
        ItemType: "sra:cup_of_blood",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "blood": {
        ItemType: "sra:cup_of_blood",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "acid": {
        ItemType: "sra:cup_of_hydrochloric_acid",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Acid": {
        ItemType: "sra:cup_of_hydrochloric_acid",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "hydrochloric acid": {
        ItemType: "sra:cup_of_hydrochloric_acid",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Hydrochloric Acid": {
        ItemType: "sra:cup_of_hydrochloric_acid",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "hydrochloric Acid": {
        ItemType: "sra:cup_of_hydrochloric_acid",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Hydrochloric acid": {
        ItemType: "sra:cup_of_hydrochloric_acid",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "Bleach": {
        ItemType: "sra:cup_of_bleach",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "bleach": {
        ItemType: "sra:cup_of_bleach",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "SCP-198": {
        ItemType: "sra:scp_198",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    },
    "scp-198": {
        ItemType: "sra:scp_198",
        Amount: 1,
        Cost: {
            ItemType: "minecraft:iron_nugget",
            Amount: 1
        }
    }
}


world.events.entityHit.subscribe(({ entity, hitBlock, hitEntity }) => {
    try {

        if (hitBlock.typeId === block.typeId && entity.typeId === "minecraft:player") {
            let inventory = entity.getComponent("minecraft:inventory").container
            let item = inventory.getItem(entity.selectedSlot)
            if (!item)
                return
            if (item.typeId !== block.InteractItem)
                return;
            return OpenMenu(entity)
        }

    } catch (e) {
        console.warn(e)
    }
})


/**
 * @description Creates a menu for the player to open 
*/
function OpenMenu(player, error = undefined) {
    const form = new ModalFormData()
        .title(error ?? `SCP-294`)
        .textField(``, `                  Drink Name`, ``)
    form.show(player).then(data => {
        if (data.canceled)
            return;
        try {
            if (!Drinks[data.formValues[0]])
                return;
            let CurrencyAmount = GetItemAmount(player.getComponent("minecraft:inventory").container, Drinks[data.formValues[0]].Cost.ItemType)
            if (CurrencyAmount < Drinks[data.formValues[0]].Cost.Amount) {
                return OpenMenu(player, `§l§4Insufficient Iron Nuggets!`)
            }
            return GiveItem(player, data.formValues[0])
        } catch (e) {
            console.warn(e)
        }
    })
}

function GetItemAmount(inventory, itemType) {
    let amount = 0
    for (let i = 0; i < inventory.size; i++) {
        let item = inventory.getItem(i)
        if (!item)
            continue;
        if (item.typeId !== itemType) {
            continue;
        }
        amount += item.amount
    }
    return amount
}

function GiveItem(player, itemName) {
    let inventory = player.getComponent("minecraft:inventory").container;
    if (inventory.emptySlotsCount > 0) {
        //If players inventory is not full then give the item in the inventory
        let itemStack = new ItemStack(Items.get(Drinks[itemName].ItemType), Drinks[itemName].Amount)
        inventory.addItem(itemStack)
    } else {
        //Create New Itemstack with given values
        let itemStack = new ItemStack(Items.get(Drinks[itemName].ItemType), Drinks[itemName].Amount)

        //Spawn Entity
        world.getDimension("overworld").spawnItem(itemStack, player.location)
    }
    player.runCommandAsync(`clear @s ${Drinks[itemName].Cost.ItemType} -1 ${Drinks[itemName].Cost.Amount}`)

}
Collapse